#include "tool.h"
#include "if_info.h"
#include "nvram.h"

#include "sysdep.h"
#include "uuid.h"
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>


// nvram saving name
#define LAN_UUID "upnp_uuid_lan"
#define WANCD_UUID "upnp_uuid_wancd"
#define WAND_UUID "upnp_uuid_wand"
#define IGD_UUID "upnp_uuid_igd"


int print_mac(char *title,char *buf);

// begin to add
char *strupr(char *str)
{
    char *string = str;

    if (str){
		for ( ; *str; ++str)
            *str = toupper(*str);
    }
    return string;
}
void mac_str_to_array(char *array,char *str)
{
	char sa[6][20];
	sscanf(str,"%[^:]:%[^:]:%[^:]:%[^:]:%[^:]:%s",sa[0],sa[1],sa[2],sa[3],
		sa[4],sa[5]);
	array[0]=strtol(sa[0],NULL,16);
	array[1]=strtol(sa[1],NULL,16);
	array[2]=strtol(sa[2],NULL,16);
	array[3]=strtol(sa[3],NULL,16);
	array[4]=strtol(sa[4],NULL,16);
	array[5]=strtol(sa[5],NULL,16);	
	array[6]='\0';
}

int get_lan_mac(char *buf)
{
    if_info_t  if_info;
    
    bzero(&if_info,sizeof(if_info_t));
    strcpy(if_info.ifname,"br0");
    
    if(getIFInfo(&if_info)==0){
        mac_str_to_array(buf,strupr(if_info.mac));
	 return 0;
    }
    return -1;
}
int get_lan_ipaddr(char *buf)
{
	char *ls=nvram_get("lan_ipaddr");	
	if (ls==NULL)
		return -1;

	strcpy(buf,ls);
	free(ls);
	return 0;
}
int get_fw_version(char *buf)
{
	
    FILE *fp;

    fp=fopen("/var/version","r");
    if(fp==NULL)
        return 0;
	
    fgets(buf,128,fp);
    fclose(fp);

    return 0;
}
int get_product_name(char *buf)//Add by Jeff - Jan.26.2005 -
{
    FILE *fp;
    char *p;

    fp=fopen("/etc/hw_id","r");
    if(fp==NULL)
        return 0;
    fgets(buf,128,fp);
    if ((p=strchr(buf,'\n'))!=NULL)
		*p='\0';
    fclose(fp);
    
    return 0;
}
int get_wan_mac(char *buf)
{
#if 0
        FILE *fp;
	char buf1[20];	
        fp=fopen("/proc/mac","r");
        if(fp==NULL){
		return -1;
        }else{
            fread(buf1,18,1,fp);
	     mac_str_to_array(buf,buf1);
            fclose(fp);
        }
#endif
    char *mac=nvram_get("wan_macaddr");	
	if (mac==NULL)
		return -1;

	strcpy(buf,mac);
	free(mac);
	
	return 0;
}
/*
 *	init uPnp device uuid v1
 */
int print_mac(char *title,char *buf)
{
	printf("%s = %x:%x:%x:%x:%x:%x \n",title,buf[0],
		buf[1],buf[2],buf[3],buf[4],buf[5]);
	return 0;
}

static char uuid_igd[40];
static char uuid_wand[40];
static char uuid_wancd[40];
static char uuid_land[40];


int init_dev_uuid(void) 
{
    char uuid_str[40];
    char buf[200]="\0";
    int wan_ok=0;
    uuid_upnp uuid;

	// get lan_uuid
    if (get_lan_mac(buf)==0) 
		uuid_create2(&uuid,buf);	
    else
		uuid_create(&uuid);
   uuid_unpack(&uuid,uuid_land);
//   nvram_set(LAN_UUID,uuid_str);
//   print_mac("lan mac",buf);
   
     // get  wan connect device uuid
     if (get_wan_mac(buf)==0) {
	 	uuid_create2(&uuid,buf);
		wan_ok=1;
     	}
     else
	 	uuid_create(&uuid);
     uuid_unpack(&uuid,uuid_wancd);
//     nvram_set(WANCD_UUID,uuid_str);
   //  print_mac("wan mac",buf);

    // get wan device uuid
     if (!wan_ok)
	 	uuid_create(&uuid);
     else
	 	uuid_create2(&uuid,buf);
     uuid_unpack(&uuid,uuid_wand);
//     nvram_set(WAND_UUID,uuid_str);

    // get igd uuid
     if (!wan_ok)
	 	uuid_create(&uuid);
     else
	 	uuid_create2(&uuid,buf);
     uuid_unpack(&uuid,uuid_igd);
//     nvram_set(IGD_UUID,uuid_str);

     return 0 ;	
//     return nvram_commit();
}

int make_upnp_xml(char *ipaddr,int port) 
{
    char hw_id[200];
    char upnp_port[10];
/*
    char *uuid_igd=NULL;
    char *uuid_wand=NULL;
    char *uuid_wancd=NULL;
    char *uuid_land=NULL;
*/
    int try=0;

   		uuid_igd[0]='\0';
    	uuid_wand[0]='\0';
    	uuid_wancd[0]='\0';
    	uuid_land[0]='\0';
    		
    while(1) {


/*
   		uuid_igd=nvram_get(IGD_UUID);
    	uuid_wand=nvram_get(WAND_UUID);
    	uuid_wancd=nvram_get(WANCD_UUID);
    	uuid_land=nvram_get(LAN_UUID);
*/

		try++;


/*		if(uuid_igd==NULL || uuid_wand==NULL || uuid_wancd==NULL ||uuid_land==NULL
	   		|| *uuid_igd=='\0' ||  *uuid_wand=='\0' ||  *uuid_wancd=='\0' || *uuid_land=='\0')*/


		if(uuid_igd[0]=='\0' ||  uuid_wand[0]=='\0' ||  uuid_wancd[0]=='\0' || uuid_land[0]=='\0')
	   		 {
	 		if (try>1){

/*
			    if(uuid_igd)
			        free(uuid_igd);
			    if(uuid_wand)
			        free(uuid_wand);
			    if(uuid_wancd)
			        free(uuid_wancd);
			    if(uuid_land)
			        free(uuid_land);
*/			        


				return -1;
			}
		init_dev_uuid();	
		} else
		  	break;
    }
    get_product_name(hw_id); 
    sprintf(upnp_port,"%d",port);
    substr("/usr/upnp/gateway.mod", "/tmp/gateway.xml", "@IPADDR#",ipaddr);
    substr("/tmp/gateway.xml", "/tmp/gateway.xml", "@UPNP_PORT#",upnp_port);
    substr("/tmp/gateway.xml", "/tmp/gateway.xml", "@UUID_IGD#",uuid_igd);
    substr("/tmp/gateway.xml", "/tmp/gateway.xml", "@UUID_WAND#",uuid_wand);
    substr("/tmp/gateway.xml", "/tmp/gateway.xml", "@UUID_WANCD#",uuid_wancd);
    substr("/tmp/gateway.xml", "/tmp/gateway.xml", "@UUID_LAND#",uuid_land);
    substr("/tmp/gateway.xml","/tmp/gateway.xml","@HW_ID#",hw_id);
	
	/*
    free(uuid_igd);
    free(uuid_wand);
    free(uuid_wancd);
    free(uuid_land);
*/			        
    return 0;
}
// end of add
