#include "nvram_k.h"

/*
* Red_liu rewrited 2008.08.07
*/

int readFileBin(char *path, char **data);
void writeFileBin(char *path, char *data, int len);

/*
* Here all functions should be redefined in nvram.h to use them
*/
extern int nvram_match(char *name, char *match);
extern int nvram_invmatch(char *name, char *invmatch);

extern int nvram_scm_commit();
extern char*  nvram_scm_getall();
extern int nvram_scm_load();
extern char* nvram_scm_get(const char *name);
extern char* nvram_scm_safe_get(const char *name);

extern char* nvram_tmp_safe_get(const char *name);
extern char* nvram_tmp_get(const char *name);
extern int nvram_tmp_set(const char* name, const char* value);

/*
* redefine all functions for other apps using.
* If you want to use these functions in some apps, you MUST
* include this nvram.h file else something will be wrong if 
* you just use -lnvram to compile without including nvram.h
*/
#define nvram_get_fun(name, path) __nvram_get_fun(name, NVRAM_TMP_PATH)
#define nvram_get_def(name) __nvram_get_fun(name, NVRAM_DEFAULT)
#define nvram_safe_get(name) nvram_scm_safe_get(name)
#define nvram_get(name) nvram_scm_get(name)
#define nvram_getall() nvram_scm_getall()
#define nvram_set(name, value) nvram_scm_set(name, value)
#define nvram_unset(name) nvram_scm_unset(name)

#define nvram_show() nvram_scm_show()
#define nvram_load() nvram_scm_load()
#define nvram_commit() nvram_scm_commit()

#define nvram_match(name, match) nvram_match(name, match)
#define nvram_invmatch(name, invmatch) nvram_invmatch(name, invmatch)

extern char* nvram_scm_get_n(const char *name , int n);
extern char* nvram_tmp_get_n(const char *name , int n);
extern char* nvram_scm_safe_get_n(const char *name , int n);
extern char* nvram_tmp_safe_get_n(const char *name , int n);
extern int nvram_scm_set_n(const char *name, int n, const char* value);
extern int nvram_tmp_set_n(const char *name, int n, const char* value);

/*
* if you wan to use "n" serial functions , define them Here
* now only BCM WIFI using this
*/
#define nvram_get_n(name, n) nvram_scm_get_n(name, n)
#define nvram_set_n(name, n, value) nvram_scm_set_n(name, n, value)
#define nvram_int_n(name, n) nvram_scm_int_n(name, n)
/*
* Here all functions are for BCM WPS application using
* You must not modify the functions' name and parameters
* else the BCM-WPS utiliy would fail. All these three
* functions are used for bcm wps and should be hidden to all
* other apps
*/
#ifdef BCM
/*
extern int nvram_commit();
extern char* nvram_get(const char *name);
extern int nvram_set(const char* name,const char* value);
*/
#endif


/*
* We have to redefine them even we don't enable BCM 
* Because in some application it will not include this MACRO
* under BCM module like wsc_det and You have to know that 
* this file was not belong to nvram_set but to other apps.
*/
#define nvram_bcm_safe_get(msg) nvram_tmp_safe_get(msg)
#define nvram_bcm_get(name) nvram_tmp_get(name)
#define nvram_bcm_set(name, value) nvram_tmp_set(name, value)
#define nvram_bcm_unset(name) nvram_tmp_unset(name)
#define nvram_bcm_show() nvram_tmp_show()

